
<script setup>
// 引入依赖
import api from '@/api/article'
import capi from '@/api/course'
import custom from '@/utils/custom'
import { formatDate } from '@/utils/format'
import _ from 'lodash'
// import { toSQLLine } from '@/utils/stringFun'
import WarningBar from '@/components/warningBar/warningBar.vue'
import ckEditor from '@/components/richText/ckEditor5.vue'
import { ref, onMounted } from 'vue'
import { ElMessage, ElMessageBox } from 'element-plus'
import { useRouter, useRoute } from 'vue-router'
const router = useRouter()
const route = useRoute()
const path = ref(import.meta.env.VITE_BASE_API)
import { useUserStore } from '@/pinia/modules/user'
const userStore = useUserStore()
// 变量
// const typeList = custom.getExercisesTypeList()
const queryParams = ref({
  page: 1,
  pageSize: 10,
  // name: '',
  // type: '',
  // subject: ''
})
// const subjectParams = ref({
//   page: 1,
//   pageSize: 100,
// })
const tableData = ref([])
// const subjectList = ref([])
const deleteVisible = ref(false)
const question_ids = ref([])
const total = ref(0)
const dialogFormVisible = ref(false)
const dialogTitle = ref('')
const form = ref({})
const rules = ref({
  title: [{ required: true, message: '请输入标题', trigger: 'blur' }],
  content: [{ required: true, message: '请输入内容', trigger: 'blur' }]
})
// const question_id = ref(0)
// const content = ref(null)
// const options = ref([]) // 答案选项数组
const question_form = ref({
  options: [],
  answer: '',
  title: ''
})
// 生命周期
onMounted(() => {
  getArticleList()
  // getSubject()
})
// 方法
async function getArticleList() {
  const res = await api.getArticleList(queryParams.value)
  if (res.code === 0) {
    tableData.value = res.data.list
    console.log(tableData.value)
    total.value = res.data.total
  }
}
// async function getSubject() { // 获取课程分类
//     const res = await capi.getSubjectList(subjectParams.value)
//     if (res.code === 0) {
//         subjectList.value = custom.getStdSubject(res.data.records)
//     }
// }
function onSubmit() {
  getArticleList()
}
const onReset = () => {
  queryParams.value = {
    page: 1,
    pageSize: 10,
    name: '',
    // status: '',
    // subject: ''
  }
}
function openDialog(type) {
  // let params = {}
  switch (type) {
    case 'add':
      dialogTitle.value = '新增文章'
      form.value = {}
      break
    case 'edit':
      // params.question_id = question_id.value
      dialogTitle.value = '编辑文章'
      break
  }
  dialogFormVisible.value = true
  // router.push({name:'addCourse',params})
}
async function onDelete() {
  const ids = question_ids.value.map(item => item.question_id)
  const res = await api.delExercises({ question_ids: ids })
  if (res.code === 0) {
    ElMessage({
      type: 'success',
      message: res.msg
    })
    // if (tableData.value.length === ids.length && page.value > 1) {
    //   page.value--
    // }
    deleteVisible.value = false
    getArticleList()
  }
}
const handleSelectionChange = (val) => {
  question_ids.value = val
}
function editFunc(row) {
  form.value = _.cloneDeep(row)
  // question_id.value = form.value.question_id
  // content.value = JSON.parse(form.value.question).title
  // question_form.value = JSON.parse(form.value.question)
  // if (!question_form.value.options) {
  //   question_form.value.options = []
  // }
  openDialog('edit')
}
function deleteFunc(row) {
  ElMessageBox.confirm('此操作将永久删除该数据, 是否继续?', '提示', {
    confirmButtonText: '确定',
    cancelButtonText: '取消',
    type: 'warning'
  })
    .then(async() => {
      const res = await api.deleteFunc({
        id: row.ID
      })
      if (res.code === 0) {
        ElMessage({
          type: 'success',
          message: '删除成功!'
        })
        getArticleList()
      }
    }, () => {
    })
}
function handleCurrentChange(val) {
  queryParams.value.page = val
  getArticleList()
}
function handleSizeChange(val) {
  queryParams.value.pageSize = val
  getArticleList()
}
function closeDialog() {
  dialogFormVisible.value = false
  question_form.value = {
    options: [],
    answer: '',
    title: ''
  }
  form.value = {}
}
async function enterDialog() { // 提交
//   form.value.score = parseInt(form.value.score)
//   form.value.teacher_id = 0
//   form.value.question = JSON.stringify(question_form.value)
  let func_name = 'addArticle'
  if (form.value.ID) { // 编辑
    func_name = 'editArticle'
  }
  const res = await api[func_name](form.value)
  if (res.code === 0) {
    ElMessage({
      type: 'success',
      message: res.msg
    })
    // if (tableData.value.length === ids.length && page.value > 1) {
    //   page.value--
    // }
    // deleteVisible.value = false
    closeDialog()
    getArticleList()
  }
}
function viewCourseFunc(row) { // 查看课程
  router.push({ name: 'viewCourse', params: { question_id: row.question_id }})
}
function getExercisesName(row) {
  return JSON.parse(row.question).title
}
const std_options_title = ref(['A', 'B', 'C', 'D', 'E', 'F'])
function addOptionFunc() {
  // for(let i=0 ;i<std_options_title.value.length;i++) {
  //     if(!options.value.has(std_options_title.value[i])) {
  //       options.value.set(std_options_title.value[i],'')
  //       break;
  //     }
  // }

  for (let i = 0; i < std_options_title.value.length; i++) {
    let has_flag = false
    for (const item of question_form.value.options) {
      if (item.name === std_options_title.value[i]) {
        has_flag = true
      }
    }
    if (!has_flag) {
      const data = {
        name: std_options_title.value[i],
        value: ''
      }
      question_form.value.options.push(data)
      break
    }
  }
}
function delet_func(item) {
  question_form.value.options.pop()
}
function handleAvatarSuccess(res) {
  console.log(res)
  form.value.cover_img = res.data.file.url
}
function beforeAvatarUpload(file) {
  const isLt05M = file.size / 1024 / 1024 < 20
  const isJPG = file.type.indexOf('image/') === -1
  if (isJPG) {
    ElMessage.error('文件格式错误，请上传图片类型,如：JPG，PNG后缀的文件')
  }
  if (!isLt05M) {
    ElMessage.error('上传头像图片大小不能超过 2M!')
  }
  return !isJPG && isLt05M
}
</script>
<template>
  <div>
    <!--    搜索框-->
    <div class="gva-search-box">
      <el-form ref="searchForm" :inline="true" :model="queryParams">
        <el-form-item label="文章名称">
          <el-input v-model="queryParams.name" placeholder="根据文章名称进行查询" />
        </el-form-item>
        <!-- <el-form-item label="课程分类">
          <el-select v-model="queryParams.subject" clearable placeholder="请选择">
            <el-option v-for="item in subjectList" :key="item.id" :label="item.name" :value="item.name" />
          </el-select>
        </el-form-item>
        <el-form-item label="题型">
          <el-select v-model="queryParams.type" clearable placeholder="请选择">
            <el-option v-for="item in typeList" :key="item.value" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item> -->
        <el-form-item>
          <el-button size="small" type="primary" icon="search" @click="onSubmit">查询</el-button>
          <el-button size="small" icon="refresh" @click="onReset">重置</el-button>
        </el-form-item>
      </el-form>
    </div>
    <!--    表格数据-->
    <div class="gva-table-box">
      <!--      批量操作-->
      <div class="gva-btn-list">
        <el-button size="small" type="primary" icon="plus" @click="openDialog('add')">新增</el-button>
        <el-popover v-model="deleteVisible" placement="top" width="160">
          <p>确定要删除吗？</p>
          <div style="text-align: right; margin-top: 8px;">
            <el-button size="small" type="primary" link @click="deleteVisible = false">取消</el-button>
            <el-button size="small" type="primary" @click="onDelete">确定</el-button>
          </div>
          <!-- <template #reference>
            <el-button
              icon="delete"
              size="small"
              type="danger"
              :disabled="!question_ids.length"
              style="margin-left: 10px;"
              @click="deleteVisible = true"
            >删除</el-button>
          </template> -->
        </el-popover>
      </div>
      <!--   数据列表-->
      <el-table :data="tableData" @selection-change="handleSelectionChange">
        <!-- <el-table-column type="selection" width="55" /> -->
        <el-table-column align="left" label="ID" min-width="60" prop="ID" sortable="custom" />
        <el-table-column align="left" label="标题" min-width="150" prop="title">
          <!-- <template #default="scope">
            {{ custom.getExercisesTypeName(scope.row.type) }}
          </template> -->
        </el-table-column>
        <el-table-column align="left" label="内容" min-width="150" prop="subject">
          <template #default="scope">
              <div class="show-content text-ellipsis-1" v-html="scope.row.content"></div>
          </template>
        </el-table-column>
        <el-table-column align="left" label="封面图" min-width="150">
          <template #default="scope">
              <img class="lbt-thumb" :src="scope.row.cover_img" alt="">
            </template>
        </el-table-column>
        <el-table-column align="left" label="阅读量" prop="reading_num" />
        <!-- <el-table-column align="left" label="创建者" min-width="150" prop="teacher_id" /> -->
        <el-table-column align="left" label="创建时间" min-width="150">
          <template #default="scope">
            {{ formatDate(scope.row.CreatedAt) }}
          </template>
        </el-table-column>
        <el-table-column align="left" fixed="right" label="操作" width="200">
          <template #default="scope">
            <el-button
              icon="edit"
              size="small"
              type="primary"
              link
              @click="editFunc(scope.row)"
            >编辑</el-button>
            <el-button
              icon="delete"
              size="small"
              type="danger"
              link
              @click="deleteFunc(scope.row)"
            >删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="gva-pagination">
        <el-pagination
          :current-page="queryParams.page"
          :page-size="queryParams.pageSize"
          :page-sizes="[10, 30, 50, 100]"
          :total="total"
          layout="total, sizes, prev, pager, next, jumper"
          @current-change="handleCurrentChange"
          @size-change="handleSizeChange"
        />
      </div>

    </div>
    <el-dialog v-model="dialogFormVisible" :before-close="closeDialog" :title="dialogTitle">
      <el-form ref="apiForm" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="标题" prop="title">
          <!-- <el-select v-model="form.subject" clearable placeholder="请选择">
            <el-option v-for="item in subjectList" :key="item.id" :label="item.name" :value="item.name" />
          </el-select> -->
          <el-input v-model="form.title" />
        </el-form-item>
        <!-- <el-form-item label="科目" prop="subject">
          <el-select v-model="form.subject" clearable placeholder="请选择">
            <el-option v-for="item in subjectList" :key="item.id" :label="item.name" :value="item.name" />
          </el-select>
        </el-form-item>
        <el-form-item label="题型" prop="type">
          <el-select v-model="form.type" clearable placeholder="请选择">
            <el-option v-for="item in typeList" :key="item.value" :label="item.label" :value="item.value" />
          </el-select>
        </el-form-item> -->
        <el-form-item label="封面" prop="cover_img">
          <el-upload
            class="avatar-uploader"
            :action="`${path}/fileUploadAndDownload/upload`"
            :headers="{ 'x-token': userStore.token }"
            :show-file-list="false"
            :on-success="handleAvatarSuccess"
            :before-upload="beforeAvatarUpload"
          >
            <img v-if="form.cover_img" :src="form.cover_img" class="img-container">
            <el-icon v-else class="avatar-uploader-icon"><Plus /></el-icon>
          </el-upload>
        </el-form-item>
        <el-form-item label="文章内容">
          <ckEditor v-model="form.content" style="width:100%" :content="form.content" />
        </el-form-item>
        <el-form-item label="阅读量" prop="reading_num">
          <el-input v-model.number="form.reading_num" />
        </el-form-item>
        <!-- <el-form-item label="分值">
          <el-input v-model="form.score" type="number" placeholder="请输入分值" />
        </el-form-item>
        <el-form-item label="答案">
          <view class="options-box">
            <view v-for="(item, i) in question_form.options" v-if="question_form" class="option-item">
              <view>{{ item.name }}</view>
              <ckEditor v-model="item.value" :content="item.value" style="margin-left:5px;width:100%" />
              <el-icon
                v-if="(i + 1) == question_form.options.length"
                style="margin-left: 5px;cursor: pointer"
                @click="delet_func(item)"
              >
                <Delete />
              </el-icon>
            </view>
            <el-button @click="addOptionFunc">添加答案</el-button>
          </view>
        </el-form-item>
        <el-form-item label="正确答案">
          <el-input v-model="question_form.answer" placeholder="请输入正确答案（如，选择题：A或A-B；填空题直接填值）" />
        </el-form-item>
        <el-form-item label="题目解析">
          <ckEditor v-model="form.resolve" style="width:100%" :content="form.resolve" />
        </el-form-item> -->
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button size="small" @click="closeDialog">取 消</el-button>
          <el-button size="small" type="primary" @click="enterDialog">确 定</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>
<style scoped lang="scss">
.option-item {
    display: flex;
    align-items: center;
    margin-bottom: 10px;
}
.text-ellipsis-1{ /*超出部分省略号 单行*/
	overflow:hidden;
	text-overflow: ellipsis;
	-webkit-line-clamp: 1;
	display: -webkit-box;
	-webkit-box-orient: vertical;
	/* min-height: 38rpx; */
}
.button-box {
    padding: 10px 20px;

    .el-button {
        float: right;
    }
}

.warning {
    color: #dc143c;
}
.lbt-thumb{
    width: 100px;
    height: 50px;
  }
</style>
